

console.log('Machinaryproductjs')
var machineId;
var machinery_primary_id;
$(document).ready(function () {

    var mytable = $('#myTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "machinery_primary_id" },
            { "data": "id" },
            { "data": "name" },
            { "data": "site" },

        ],
        columnDefs: [
            { width: 100, targets: 0, "visible": false },
            { width: 200, targets: 1 },
        ],
    });
    var machinaryProductTable = $('#machinaryProductTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "product_id" },
            { "data": "product_name" },
            { "data": "machine" },
            { "data": "quantity" },
            { "data": "edit" },
            { "data": "delete" },
            { "data": "status" },

        ],
        columnDefs: [
            { width: 100, targets: 0, },
            { width: 150, targets: 2 },
            { width: 80, targets: 3 },
            { width: 80, targets: 4 },
            { width: 80, targets: 5 },
        ],
    });
    loadData();
    loadProduct();


    $('#myTable tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            mytable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = mytable.row(this).data();
            console.log(rowData.id);
            machineId = rowData.id;
            machinery_primary_id = rowData.machinery_primary_id;
            allMachineryProduct(machinery_primary_id);

        }
    });



    loadUnitOfMesurement()
});
function loadUnitOfMesurement() {
    $.ajax({
        type: 'GET',
        url: '/st/product/loadUnitOfMesurement',
        async: false,
        success: function (response) {
            console.log(response.data.result)
            if (response.data.success) {
                var html = "";
                $.each(response.data.result, function (index, value) {

                    html += '<option value="' + value.id + '" > ' + value.name + ' </option>';
                });
                $('#txtUnitOfMesurement').append(html);


            }
        }, error: function (data) {
            console.log(data);
            console.log('something went wrong');
        }
    });
}

$('#btnProduct').on('click', function () {
    $('#machineryId').val(machineId);
    $('#btnSaveProduct').text('Save');
    // loadProduct();
    $('#productModel').modal('show');

});

$('#btnSaveProduct').on('click', function () {
    if ($('#btnSaveProduct').text() == 'update') {
        var form = $('#machinary_productfrm').get(0);
        var data = new FormData(form);
        update(data);
    } else {
        var form = $('#machinary_productfrm').get(0);
        var data = new FormData(form);
        data.append('machine_id', machinery_primary_id);
        save(data);
    }


});
function loadData() {
    $.ajax({
        type: 'GET',
        url: '/pp/machinery/load',
        success: function (response) {
            console.log(response)
            if (response.data.success) {
                var disable = { 0: "", 1: "checked" };

                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var name = response.data.result[i]['machinery_name'];
                    var machinery_primary_id = response.data.result[i]['machinery_id'];
                    var id = response.data.result[i]['machinery_no'];
                    var SiteId = response.data.result[i]['site_id'];
                    var SiteName = response.data.result[i]['site'];

                    var status = response.data.result[i]['status'];
                    data.push({
                        "machinery_primary_id": machinery_primary_id,
                        "id": id,
                        "name": name,
                        // "thSiteId":SiteId ,
                        "site": SiteName,
                        // "edit":'<button class="btn btn-primary" onclick="edit('+id+')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        // "delete": '<button class="btn btn-danger" onclick="_delete('+id+')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                        // "Status":'<label class="switch"><input type="checkbox" onchange="disable(event,' + id + ')"  id="' + response.data.result[i].machinery_id + '"  ' + disable[ response.data.result[i].status] + '><span class="slider round"></span></label>',
                        // "Status":'<input type="checkbox" id="' + response.data.result[i].machinery_id + '" onchange="disable(event,' + "'country'" + ')" ' + disable[ response.data.result[i].status] + '>',


                    });
                }



                var table = $('#myTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        }, error: function (data) {
            // console.log('something went wrong');
        }
    });
}

function loadProduct() {
    $.ajax({
        type: 'GET',
        url: '/pp/machinery_Products/loadProducts',
        success: function (response) {
            console.log(response);
            var html = "";
            //   console.log(response.data.result);
            $.each(response.data.result, function (index, value) {
                html += '<option value="' + value.product_primary_id + '" > ' + value.product_name + ' </option>';
            });
            $('#product_nameDropDown').html(html);
        }, error: function (data) {
            // console.log('something went wrong');
        }
    });
}

function save(data) {

    // console.log(name);
    if(isAssignProductToMachine(machinery_primary_id,$('#product_nameDropDown').val())){
        showWarningMessage("Already assigned this product.");
        return;
    }

    var request = $.ajax({
        url: "/pp/machinery_product/save",
        headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
        type: "POST",
        enctype: 'multipart/form-data',
        data: data,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        success: function (data) {

            console.log(data);

            if (data.data.success) {
                showSuccessMessage("Data has been enabled successfully...");
                $('#productModel').modal('hide');
                allMachineryProduct(machinery_primary_id);

            }
            if (!data.data.success) {
                // console.log(data.data.result.errorInfo[2])
                toastr.error(data.data.result.errorInfo[2]);
                //loadMachinaryProduct(machineId);

            }


        },
        error: function (data) {
            console.log(data);
        },

    });
}

/*function loadMachinaryProduct(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/machinery_product/load/' + id,
        success: function (response) {
            console.log(response)
            if (response.data.success) {
                var disable = { 0: "", 1: "checked" };

                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var machinename = response.data.result[i]['machinery_name'];
                    var product_name = response.data.result[i]['product_name'];
                    var quantity = response.data.result[i]['quantity'];
                    var machinery_product_id = response.data.result[i]['machinery_product_id'];
                    var status = response.data.result[i]['status'];
                    data.push({
                        "product_id": "",
                        "product_name": product_name,
                        "quantity": quantity,
                        "edit": '<button class="btn btn-primary" onclick="edit(' + machinery_product_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        "delete": '<button class="btn btn-danger" onclick="_delete(' + machinery_product_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                        "status": '<label class="switch"><input type="checkbox" onchange="disable(event,' + machinery_product_id + ')"  id="' + response.data.result[i].machinery_product_id + '"  ' + disable[response.data.result[i].status] + '><span class="slider round"></span></label>',
                        // "Status":'<input type="checkbox" id="' + response.data.result[i].machinery_product_id + '" onchange="disable(event,' + "'country'" + ')" ' + disable[ response.data.result[i].status] + '>',


                    });
                }



                var table = $('#machinaryProductTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        }, error: function (data) {
            // console.log('something went wrong');
        }
    });
}*/






function _delete(id) {
    $.ajax({
        type: 'DELETE',
        headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
        url: '/pp/machinery_product/delete/' + id,
        success: function (response) {
            console.log(response);
            allMachineryProduct(machinery_primary_id);
        }, error: function (data) {
            // console.log('something went wrong');
        }
    });
}





function disable(event, id) {


    var status = 0;
    if (event.target.checked) {
        status = 1;
    }

    $.ajax({
        type: 'PUT',
        url: '/pp/machinery_product/Disable/' + id,
        //async:false,
        data: {
            "status": status
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                showSuccessMessage("Product has been disabled successfully...");
                allMachineryProduct(machinery_primary_id);
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}




function edit(id) {
    $.ajax({
        type: 'GET',
        url: '/pp/machinery_product/edit/' + id,
        success: function (response) {




            $('#productModel').modal('show');
            $('#quantity').val(response.data.result.quantity);
            $('#machineryId').val(response.data.result.machinery_id);
            $('#machinery_product_id').val(response.data.result.machinery_product_id);
            $('#wastage').val(response.data.result.wastage);
            //$('#umo').val(response.data.result.umo);
            setSelectedOption('txtUnitOfMesurement', response.data.result.umo);


            $('#product_nameDropDown').val(response.data.result.product_Id);
            $('#btnSaveProduct').text('update');

            console.log($('#machineryId').val())


        }, error: function (data) {
            // console.log('something went wrong');
        }
    });
}





function update(data) {


    // var machinery_id=$('#machineryId').val();
    // var product_Id= $('#product_Id').val();
    // var quantity= $('#quantity').val();
    var id = $('#machinery_product_id').val();
    // console.log(machinery_id);

    var request = $.ajax({
        url: "/pp/machinery_product/update/" + id,
        headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
        type: "post",
        enctype: 'multipart/form-data',
        //    data: {"machinery_id":machinery_id,"product_Id":product_Id,"quantity":quantity},
        data: data,
        processData: false,
        contentType: false,
        success: function (data) {

            console.log(data);

            if (data.data.success) {
                showSuccessMessage("Data has been saved successfully...");
                $('#productModel').modal('hide');
                allMachineryProduct(machinery_primary_id);
                //loadMachinaryProduct(machineId);

            }


        },
        error: function (data) {
            console.log(data);
        },

    });
}
function showSuccessMessage(message) {

    toastr.success(message);
}




function isAssignProductToMachine(machine_id, product_id) {
    var bool = false;
    $.ajax({
        type: 'GET',
        url: '/pp/machinery_product/isAssignProductToMachine/' + machine_id + "/" + product_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            bool = response.data.result;
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return bool;
}




function allMachineryProduct(machine_id) {

    $.ajax({
        type: "GET",
        url: "/pp/machinery_product/allMachineryProduct/" + machine_id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                var data = [];
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['machinery_product_id'];
                    var machinery_id = response.data.result[i]['machinery_id'];
                    var product_id = response.data.result[i]['product_id'];
                    var product_name = response.data.result[i]['product_name'];
                    var machinery_no = response.data.result[i]['machinery_no'];
                    var machinery_name = response.data.result[i]['machinery_name'];
                    var site = response.data.result[i]['site'];
                    var quantity = response.data.result[i]['quantity'];
                    var string_id = "'" + machinery_id + "'";
                    var status = "";
                    if (response.data.result[i]['status'] == 1) {
                        status = "checked";
                    }
                    data.push({
                        "product_id": product_id,
                        "product_name": product_name,
                        "machine": machinery_name,
                        "quantity": quantity,
                        "edit": '<button class="btn btn-primary" onclick="edit(' + id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
                        "delete": '<button class="btn btn-danger" onclick="_delete(' + id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
                        "status": '<label class="switch"><input type="checkbox" onchange="disable(event,' + id + ')"  id="' + response.data.result[i].machinery_product_id + '"  ' + status + '><span class="slider round"></span></label>',

                    });
                }


                var table = $('#machinaryProductTable').DataTable();
                table.clear();
                table.rows.add(data).draw();


            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}

function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}



/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
